## ros-humble-novatel-oem7-driver 20.1.0

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.10)
project(novatel_oem7_driver)


## Compile as C++14, supported on ROS2
set(CMAKE_CXX_STANDARD 14)

find_package(ament_cmake REQUIRED)

find_package(pluginlib)
find_package(rclcpp REQUIRED) 
find_package(rclcpp_components REQUIRED) 
find_package(std_msgs REQUIRED)
find_package(gps_msgs REQUIRED)
find_package(sensor_msgs REQUIRED)
find_package(nmea_msgs REQUIRED)
find_package(nav_msgs REQUIRED)
find_package(tf2_geometry_msgs REQUIRED)
find_package(novatel_oem7_msgs REQUIRED)
find_package(Boost  			REQUIRED)

LIST(APPEND CMAKE_MODULE_PATH "/usr/share/cmake/geographiclib")

find_package(GeographicLib REQUIRED)

# Make package available as a macro to C++
add_definitions("-D${PROJECT_NAME}_VERSION=\"${${PROJECT_NAME}_VERSION}\"")

###########
## Build ##
###########



# Log environment
message(STATUS "System Host Proc: '${CMAKE_HOST_SYSTEM_PROCESSOR}'")
message(STATUS "System Proc: '${CMAKE_SYSTEM_PROCESSOR}'")
message(STATUS "VOID_P: ${CMAKE_SIZEOF_VOID_P}")


set(OEM7_DECODER novatel_oem7_decoder)



include(ExternalProject)
ExternalProject_Add(${OEM7_DECODER}
  GIT_REPOSITORY https://github.com/novatel/novatel_edie
  GIT_TAG origin/dev-ros_install_prefix
  UPDATE_DISCONNECTED TRUE
  PREFIX ${CMAKE_BINARY_DIR}/${OEM7_DECODER}
  CMAKE_ARGS -DCMAKE_INSTALL_PREFIX:PATH=${CMAKE_BINARY_DIR} -DVERSION=1.0.0.2
)


set(OEM7_DECODER_DIR ${CMAKE_BINARY_DIR}/${OEM7_DECODER}/src/${OEM7_DECODER})

include_directories(include
    src
    ${OEM7_DECODER_DIR}	
    ${OEM7_DECODER_DIR}/src
    ${CMAKE_BINARY_DIR}/usr/include/novatel/edie           
    ${OEM7_DECODER_DIR}/bin/Novatel/api/
    ${OEM7_DECODER_DIR}/bin/StreamInterface/api/
)

## All components are plugins
add_library(${PROJECT_NAME} SHARED
   src/oem7_receiver_net.cpp
   src/oem7_receiver_port.cpp
   src/oem7_receiver_file.cpp
   src/oem7_message_decoder.cpp
   src/oem7_message_decoder_lib.cpp
   src/oem7_message_util.cpp
   src/oem7_ros_messages.cpp
   src/oem7_debug_file.cpp
   src/bestpos_handler.cpp
   src/ins_handler.cpp
   src/align_handler.cpp
   src/time_handler.cpp
   src/receiverstatus_handler.cpp
   src/nmea_handler.cpp
   src/odometry_handler.cpp
   src/oem7_imu.cpp
)

## All components are plugins
add_executable(${PROJECT_NAME}_exe
   src/oem7_message_node.cpp
   src/oem7_message_util.cpp
   src/oem7_ros_messages.cpp
   src/message_handler.cpp
) 



message("Linking to EDIE at: '${CMAKE_BINARY_DIR}'")

target_link_libraries(${PROJECT_NAME}
   Boost::boost
   ${GeographicLib_LIBRARIES}
   ${CMAKE_BINARY_DIR}/usr/lib/libCommon.a
   ${CMAKE_BINARY_DIR}/usr/lib/libStreamInterface.a
   ${CMAKE_BINARY_DIR}/usr/lib/libNovatel.a
   ${CMAKE_BINARY_DIR}/usr/lib/libCommon.a   
)

add_dependencies(${PROJECT_NAME} ${OEM7_DECODER})

ament_target_dependencies(${PROJECT_NAME} 
	pluginlib
	std_msgs 
	gps_msgs
	sensor_msgs 
	nmea_msgs 	
	nav_msgs
	tf2_geometry_msgs 
	novatel_oem7_msgs
)


ament_target_dependencies(${PROJECT_NAME}_exe 
    rclcpp
    rclcpp_components
	pluginlib
	novatel_oem7_msgs 
)


install(TARGETS
  ${PROJECT_NAME}_exe
  DESTINATION lib/${PROJECT_NAME}
)

if(BUILD_TESTING)
	SET(TEST_DIR ${CMAKE_CURRENT_SOURCE_DIR}/test)
	find_package(launch_testing_ament_cmake)

 	add_launch_test(
		test/align.test.py
		ARGS "test_name:=align"
	 	ARGS "test_dir:=${TEST_DIR}" 
	 	ARGS "oem7_file_name:=${TEST_DIR}/align.gps"
	 	)
	 	
 	add_launch_test(
		test/bestpos.test.py
		ARGS "test_name:=bestpos"
 		ARGS "test_dir:=${TEST_DIR}" 
 		ARGS "oem7_file_name:=${TEST_DIR}/bestpos.gps"
 	)
 	
 	add_launch_test(
		test/ins1.test.py
		ARGS "test_name:=ins1"
 		ARGS "test_dir:=${TEST_DIR}" 
 		ARGS "oem7_file_name:=${TEST_DIR}/ins1.gps"
 	)
 	
 	add_launch_test(
		test/ins2.test.py
		ARGS "test_name:=ins2"
 		ARGS "test_dir:=${TEST_DIR}" 
 		ARGS "oem7_file_name:=${TEST_DIR}/ins2.gps"
 	)

 	add_launch_test(
		test/rxstatus.test.py
		ARGS "test_name:=rxstatus"
 		ARGS "test_dir:=${TEST_DIR}" 
 		ARGS "oem7_file_name:=${TEST_DIR}/rxstatus.gps"
 	)
 	
 	add_launch_test(
		test/time.test.py
		ARGS "test_name:=time"
 		ARGS "test_dir:=${TEST_DIR}" 
 		ARGS "oem7_file_name:=${TEST_DIR}/time.gps"
 	)
	 	
endif()


#############
## Install ##
#############

ament_export_dependencies(ament_cmake)
ament_export_include_directories(include)
pluginlib_export_plugin_description_file(${PROJECT_NAME} novatel_oem7_driver_plugins.xml)

## Mark executables and/or libraries for installation
install(TARGETS ${PROJECT_NAME} 
   ARCHIVE DESTINATION lib 
   LIBRARY DESTINATION lib 
   RUNTIME DESTINATION bin} 
)

install(FILES ${PROJECT_NAME}_plugins.xml DESTINATION share)
install(DIRECTORY config DESTINATION share/${PROJECT_NAME} FILES_MATCHING PATTERN "*.yaml")
install(DIRECTORY launch DESTINATION share/${PROJECT_NAME} FILES_MATCHING PATTERN "*.py")
install(DIRECTORY launch DESTINATION share/${PROJECT_NAME} FILES_MATCHING PATTERN "*.launch")


ament_python_install_package(${PROJECT_NAME})

ament_package()

=== debian/changelog ===
ros-humble-novatel-oem7-driver (20.1.0-1jammy) jammy; urgency=high

  * Autogenerated, no changelog for this version found in CHANGELOG.rst.

 -- NovAtel Support <support.novatel@hexagon.com>  Mon, 24 Apr 2023 16:58:29 -0000

ros-humble-novatel-oem7-driver (20.0.0-1jammy) jammy; urgency=high

  Formal support for Humble; functionality updated to that of ROS1 v4.2.0
  Features:
  * BESTGNSSPOS, PPPPOS, TERRASTARINFO, TERRASTARSTATUS Oem7 Messages
  * imu/data_raw output, source from RAWIMUSX and scaled
  * HG4930_AN04, HG4930_AN04_400Hz IMUs
  * Odometry Angular velocities
  * Optionally, publish Odometry Transform
  * Optionally, use first valid GPSFix as Odometry Pose origin
  Fixes:
  * Rotate Odometry Twist covariances into local frame

 -- NovAtel Support <support.novatel@hexagon.com>  Tue, 18 Apr 2023 07:00:00 -0000

ros-humble-novatel-oem7-driver (10.5.0-1jammy) jammy; urgency=high

  Misc ROS2 fixes

 -- NovAtel Support <support.novatel@hexagon.com>  Fri, 12 Nov 2021 08:00:00 -0000

ros-humble-novatel-oem7-driver (10.0.0-1jammy) jammy; urgency=high

  Initial Support for ROS2/Foxy

 -- NovAtel Support <support.novatel@hexagon.com>  Tue, 31 Aug 2021 07:00:00 -0000

ros-humble-novatel-oem7-driver (2.2.0-1jammy) jammy; urgency=high

  * No feature changes
  * More robust support for compillation for 32 vs. 64 bit targets

 -- NovAtel Support <support.novatel@hexagon.com>  Wed, 03 Feb 2021 08:00:00 -0000

ros-humble-novatel-oem7-driver (2.1.0-1jammy) jammy; urgency=high

  * Support for ARM builds: arm32v7, arm64v8 (#1 <https://github.com/novatel/novatel_oem7_driver/issues/1>)
  * Initialization command mechanism robustness improvements

 -- NovAtel Support <support.novatel@hexagon.com>  Thu, 28 Jan 2021 08:00:00 -0000

ros-humble-novatel-oem7-driver (2.0.0-1jammy) jammy; urgency=high

  * Support logging 'unknown' OEM7 messages under Oem7Raw topic
  * Populate gps_common/GPSStatus.status with more detailed status info
  * Source gps_common/GPSFix, gps_common/NavSatFix position data from the most recent and higher quality
    INSPVAS or BESTPOS/BESTVEL messsage.Previously, position data was always sourced from BESTPOS/BESTVEL, which is transmitted
    at lower rate than INSPVAS
    (#13 <https://github.com/novatel/novatel_oem7_driver/issues/13>)
  * Support nmea_msgs/Sentence for all OEM7 NMEA0183 messages (#4 <https://github.com/novatel/novatel_oem7_driver/issues/4>)
  * Support nav_msgs/Odometry, with position and orientation populated based on BESTPOS/BESTVEL/INSPVAS
    (#8 <https://github.com/novatel/novatel_oem7_driver/issues/8>)

 -- NovAtel Support <support.novatel@hexagon.com>  Fri, 18 Dec 2020 08:00:00 -0000

ros-humble-novatel-oem7-driver (1.1.0-1jammy) jammy; urgency=high

  * No feature changesBuild fixes and documentation improvements.

 -- NovAtel Support <support.novatel@hexagon.com>  Sat, 02 May 2020 07:00:00 -0000

ros-humble-novatel-oem7-driver (1.0.0-1jammy) jammy; urgency=high

  * Initial release

 -- NovAtel Support <support.novatel@hexagon.com>  Mon, 20 Apr 2020 07:00:00 -0000

=== debian/control ===
Source: ros-humble-novatel-oem7-driver
Section: misc
Priority: optional
Maintainer: NovAtel Support <support.novatel@hexagon.com>
Build-Depends: debhelper (>= 9.0.0), libboost-all-dev, libgeographic-dev, ros-humble-ament-cmake, ros-humble-gps-msgs, ros-humble-launch-testing <!nocheck>, ros-humble-launch-testing-ament-cmake <!nocheck>, ros-humble-launch-testing-ros <!nocheck>, ros-humble-nav-msgs, ros-humble-nmea-msgs, ros-humble-novatel-oem7-msgs, ros-humble-pluginlib, ros-humble-rclcpp, ros-humble-rclcpp-components, ros-humble-rclpy <!nocheck>, ros-humble-rosbag2 <!nocheck>, ros-humble-rosidl-runtime-py <!nocheck>, ros-humble-sensor-msgs, ros-humble-tf2-geometry-msgs, ros-humble-ros-workspace
Homepage: http://www.novatel.com
Standards-Version: 3.9.2

Package: ros-humble-novatel-oem7-driver
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, libboost-all-dev, libgeographic-dev, ros-humble-gps-msgs, ros-humble-nav-msgs, ros-humble-nmea-msgs, ros-humble-novatel-oem7-msgs, ros-humble-pluginlib, ros-humble-rclcpp, ros-humble-rclcpp-components, ros-humble-sensor-msgs, ros-humble-tf2-geometry-msgs, ros-humble-ros-workspace
Description: NovAtel Oem7 ROS Driver

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1
# TODO: remove the LDFLAGS override.  It's here to avoid esoteric problems
# of this sort:
#  https://code.ros.org/trac/ros/ticket/2977
#  https://code.ros.org/trac/ros/ticket/3842
export LDFLAGS=
export PKG_CONFIG_PATH=/opt/ros/humble/lib/pkgconfig
# Explicitly enable -DNDEBUG, see:
# 	https://github.com/ros-infrastructure/bloom/issues/327
export DEB_CXXFLAGS_MAINT_APPEND=-DNDEBUG
ifneq ($(filter nocheck,$(DEB_BUILD_OPTIONS)),)
	BUILD_TESTING_ARG=-DBUILD_TESTING=OFF
endif

DEB_HOST_GNU_TYPE ?= $(shell dpkg-architecture -qDEB_HOST_GNU_TYPE)

%:
	dh $@ -v --buildsystem=cmake --builddirectory=.obj-$(DEB_HOST_GNU_TYPE)

override_dh_auto_configure:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/humble/setup.sh" ]; then . "/opt/ros/humble/setup.sh"; fi && \
	dh_auto_configure -- \
		-DCMAKE_INSTALL_PREFIX="/opt/ros/humble" \
		-DAMENT_PREFIX_PATH="/opt/ros/humble" \
		-DCMAKE_PREFIX_PATH="/opt/ros/humble" \
		$(BUILD_TESTING_ARG)

override_dh_auto_build:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/humble/setup.sh" ]; then . "/opt/ros/humble/setup.sh"; fi && \
	dh_auto_build

override_dh_auto_test:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	echo -- Running tests. Even if one of them fails the build is not canceled.
	if [ -f "/opt/ros/humble/setup.sh" ]; then . "/opt/ros/humble/setup.sh"; fi && \
	dh_auto_test || true

override_dh_shlibdeps:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/humble/setup.sh" ]; then . "/opt/ros/humble/setup.sh"; fi && \
	dh_shlibdeps -l$(CURDIR)/debian/ros-humble-novatel-oem7-driver//opt/ros/humble/lib/

override_dh_auto_install:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/humble/setup.sh" ]; then . "/opt/ros/humble/setup.sh"; fi && \
	dh_auto_install
